<?php

// Copyright (C) 2012 Jacob Barkdull, Roberto Guido
//
//   This program is free software: you can redistribute it and/or modify
//   it under the terms of the GNU Affero General Public License as
//   published by the Free Software Foundation, either version 3 of the
//   License, or (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU Affero General Public License for more details.
//
//   You should have received a copy of the GNU Affero General Public License
//   along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//--------------------
//
// Script Description:
//
//	A proper share button for Identi.ca, similar to that of 
//	Twitter's. By sending the current page URL to Identi.ca's
//	search and counting how many times it appears in the JSON 
//	feed, the script generates a number used to represent how 
//	many other people have "dented" something about the page. 
//	That number is also a link to a page where you may post a 
//	new notice containing the page title and URL.


// Display source code
if (isset($_GET["source"])) {
	header("Content-type: text/plain");
	exit(file_get_contents(__FILE__));
}

// HTML tags for each button style
$server = $_SERVER['HTTP_HOST'];
$style = '<a href="http://identi.ca/index.php?action=newnotice&status_textarea=PAGE_TITLE_HERE" + location.href + "" target="_blank" style="background-image: url(\'http://' . $server . '/identishare/share.png\'); display: inline-block; background-repeat: no-repeat; width: 40px; height: 51px; padding: 12px 11px 0px 0px !important; margin: 0px !important; font-family: \'Arial\'; font-size: 11px; text-decoration: none; line-height: 1.2em; color: #000000; text-align: center;" title="Share on Identi.ca"><b id="dent_count" style="float: none !important; margin: 0px !important;">&middot;&middot;&middot;</b></a><br>' . PHP_EOL . "\t\t" . '<span id="hidden" style="display: none;"></span>';
$wide = '<a href="http://identi.ca/index.php?action=newnotice&status_textarea=PAGE_TITLE_HERE" + location.href + "" target="_blank" style="background-image: url(\'http://' . $server . '/identishare/wide.png\'); border-radius: 4px; -moz-border-radius: 4px; -webkit-border-radius: 4px; display: inline-block; height: 22px; background-repeat: no-repeat; padding: 6px 8px 0px 98px; margin: 0px !important; font-family: \'Arial\'; font-size: 14px; text-decoration: none; line-height: normal; color: #FFFFFF; text-align: right;" title="Share on Identi.ca"><b id="dent_count" style="float: none !important; margin: 0px !important;">&middot;&middot;&middot;</b></a><br>' . PHP_EOL . "\t\t" . '<span id="hidden" style="display: none;"></span>';
$wide_small = '<a href="http://identi.ca/index.php?action=newnotice&status_textarea=PAGE_TITLE_HERE" + location.href + "" target="_blank" style="background-image: url(\'http://' . $server . '/identishare/wide.png\'); background-position: left bottom; border-radius: 4px; -moz-border-radius: 4px; -webkit-border-radius: 4px; display: inline-block; height: 16px; background-repeat: no-repeat; padding: 4px 6px 0px 74px; margin: 0px !important; font-family: \'Arial\'; font-size: 11px; text-decoration: none; line-height: normal; color: #FFFFFF; text-align: right; vertical-align: top;" title="Share on Identi.ca"><b id="dent_count" style="float: none !important; margin: 0px !important;">&middot;&middot;&middot;</b></a><br>' . PHP_EOL . "\t\t" . '<span id="hidden" style="display: none;"></span>';

$style2 = <<<STYLE2
<div style="width: 50px; height: 58px; margin: 2px 0px 4px 0px;">
			<div dir="ltr">
				<div style="height: 38px;">
					<div style="display:inline-block; background: no-repeat url('http://${server}/identishare/bubble.png'); height: 35px; width: 50px; text-align: center; overflow: hidden; padding-top: 6px; font-size: 15px; line-height: normal;">
						<a href="http://identi.ca/search/notice?q=" + location.href + "&search=Search" target="_blank" style="vertical-align: top; color: #666666; font-family: 'Arial',sans-serif;"><b id="dent_count">&middot;&middot;&middot;</b></a>
					</div>
				</div>
				<div>
					<a href="http://identi.ca/index.php?action=newnotice&status_textarea=PAGE_TITLE_HERE" + location.href + "" target="_blank" style="display: inline-block; background-image: url('http://${server}/identishare/button.png'); font-family: arial; text-decoration: none; line-height: 1.2em; color: #000000; width: 50px; height: 20px;" title="Share on Identi.ca"></a>
				</div><br>
				<span id="hidden" style="display: none;"></span>
			</div>
		</div>
STYLE2;

// Switch for button styles
if (isset($_GET['wide'])) {
	$style = (isset($_GET['small'])) ? $wide_small : $wide;
} else if (isset($_GET['style2'])) {
	$style = $style2;
}

// Switch for use in iFrame
if (!isset($_GET['noscript'])) {
	$style = str_replace(array(PHP_EOL, "\t"), '', addslashes($style));
}

// Get page title
if (isset($_GET['title'])) {
	$style = str_replace(array('PAGE_TITLE_HERE', '\" +', '+ \"'), array(str_replace(array('?', '&'), array('%3F', '%26'), $_GET['title']) . ' ', '" +', '+ "'), $style);
} else {
	if (!isset($_GET['noscript'])) {
		$style = str_replace(array('PAGE_TITLE_HERE', '\" +', '+ \"'), array('"+document.title+" - ', '" +', '+ "'), $style);
	} else {
		$style = str_replace('PAGE_TITLE_HERE', '', $style);
	}
}

// HTML tags for use in iFrame
$html = <<<HTML
<!DOCTYPE html>

<html>
	<head>
		<title>Share on Identi.ca</title>
	</head>

	<body marginwidth="0" marginheight="0">
		${style}
	</body>
</html>
HTML;

// PHP code for use in iFrame
if (isset($_GET['noscript'])) {
	if (isset($_SERVER['HTTP_REFERER'])) {
		$referrer = (isset($_SERVER['HTTP_REFERER'])) ? $_SERVER['HTTP_REFERER'] : 'http://' . $server . '/';
		$referrer_clean = str_replace(array('http://', 'www.', '/'), array('', '', '\/'), addslashes($referrer));
		$jsondata = file_get_contents('http://identi.ca/api/search.json?q=' . $referrer_clean . '&rpp=100');
		$results = substr_count($jsondata, $referrer_clean);
		$referrer = str_replace(array('?', '&'), array('%3F', '%26'), $referrer);
		if ($results <= '0') $results = '0';
	} else {
		$results = '0';
	}
	$html = str_replace('" + location.href + "', $referrer, $html);
	exit(str_replace('&middot;&middot;&middot;', $results, $html));
} else {
	header('Content-type: text/javascript');
}
?>
// Added button to "identishare" identified HTML element
document.getElementById('identishare').innerHTML = "<?php echo $style;?>";
document.getElementById('identishare').style.cssText = 'display: inline-block; vertical-align: top; overflow: hidden;';

// Setup XMLHttpRequest for Firefox, Chrome, Opera, IE 7+, Safari, and fallback for IE 5 & 6
jsonhttp = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHTTP");

// Add request output to "hidden" identified HTML element
jsonhttp.onreadystatechange = function() {
	if (jsonhttp.readyState == '4' && jsonhttp.status == '200') {
		document.getElementById('hidden').innerHTML = jsonhttp.responseText;
	}
}

// Get and clean page URL
var referrer = location.href.replace('http://', '').replace('www.', '').replace(/#.*$/g, '');
var referrer_clean = new RegExp(referrer.replace(/\?/g, '\\?').replace(/\//g, '\\\\\\/').replace(/#.*$/g, ''), 'gi');

// Get is.gd stortened referrer URL JSON feed, clean URL
jsonhttp.open('GET', 'http://is.gd/create.php?format=json&url=' + location.href, false); jsonhttp.send(null);
var isgd = document.getElementById('hidden').innerHTML.replace('{ "shorturl": "http://', '').replace('" }', '');
var isgd_jsmatch = new RegExp(isgd.replace('/', '\\\\\\/'), 'g');

// Get Identi.ca search JSON feed for referrer URL, count notices
jsonhttp.open('GET', 'http://identi.ca/api/search.json?q=*' + referrer + '&rpp=100', false); jsonhttp.send(null);
var count_one = (document.getElementById('hidden').innerHTML.match(referrer_clean) != null) ? document.getElementById('hidden').innerHTML.match(referrer_clean).length : 0;

// Get is.gd stortened referrer URL, count notices
jsonhttp.open('GET', 'http://identi.ca/api/search.json?q=' + isgd + '&rpp=100', false); jsonhttp.send(null);
var count_two = (document.getElementById('hidden').innerHTML.match(isgd_jsmatch) != null) ? document.getElementById('hidden').innerHTML.match(isgd_jsmatch).length : 0;

<?php
// Check if the script was requested by this server, count UR1.ca URLs
if (preg_match('/' . $_SERVER['HTTP_HOST'] . '/i', parse_url($_SERVER['HTTP_REFERER'], PHP_URL_HOST))) {
	$options = array(CURLOPT_POST => 1, CURLOPT_POSTFIELDS => 'longurl=' . $_SERVER['HTTP_REFERER'], CURLOPT_FOLLOWLOCATION => 1, CURLOPT_HEADER => 0, CURLOPT_RETURNTRANSFER => 1);
	$ch = curl_init('http://ur1.ca/');
	curl_setopt_array($ch, $options);
	$matches = array();

	// Find ur1.ca short URL
	preg_match('/ur1.ca\/([0-9a-zA-Z]+)/i', curl_exec($ch), $matches);

	if (!empty($matches[0])) {
		$matches_clean = str_replace('/', '\\\\\\/', $matches[0]);
		echo '// Get ur1.ca stortened referrer URL, count notices' . PHP_EOL;
		echo 'jsonhttp.open(\'GET\', \'http://identi.ca/api/search.json?q=' . $matches[0] . '&rpp=100\', false); jsonhttp.send(null);' . PHP_EOL;
		echo 'var count_three = (document.getElementById(\'hidden\').innerHTML.match(/' . $matches_clean . '/gi) != null) ? document.getElementById(\'hidden\').innerHTML.match(/' . $matches_clean . '/gi).length : 0;' . PHP_EOL;
	} else {
		echo 'var count_three = 0;' . PHP_EOL;
	}
} else {
	echo 'var count_three = 0;' . PHP_EOL;
}
?>

// Show notice count, clear hidden data
document.getElementById('dent_count').innerHTML = count_one + count_two + count_three;
document.getElementById('hidden').innerHTML = '';
